//----------------------------------------------------------------------------
//    α׷ : PHan_Lib.c
//
//         : Cho Han Cheol , LG-Nsys
//
//      ¥     : 2006.9.18
//    
//       : 2003.9.18
//
//    MPU_Type   : 
//
//    ϸ     : PHan_Lib.c
//----------------------------------------------------------------------------

/*


*/


//-----  
//
#ifndef   LIB_INCLUDE
#define  PHAN_LIB_LOCAL  
#define  PHANFONT_LOCAL
#define  PHANFONTENG_LOCAL
#include "PHan_Lib.h"
#include "PHanFont.h"
#include "PHanFontEng.h"

#include <stdio.h>
#endif




//----------------------------------------------------------------------------
//
//          TITLE : PHan_CnvCodeWan2Johab
//
//          WORK  : 
//
//----------------------------------------------------------------------------
U16 PHan_CnvCodeWan2Johab(U16 WanCode)
{
	int	index;
	U16	hcode, lcode;

	hcode = (WanCode >> 8) & 0xFF;
	lcode = WanCode & 0x0ff;

	index = (hcode - 0x0B0) * 94 + (lcode - 0x0A1);

	return wWanToJohabTable[index];
}





//----------------------------------------------------------------------------
//
//          TITLE : PHan_FontLoad
//
//          WORK  : 
//
//----------------------------------------------------------------------------
/*----------------------------------------------------------------------*/
/*	ѱ Ϲ Ʈ(24x24) bTemp1Font[72] LOADѴ.					*/
/*----------------------------------------------------------------------*/
U16 PHan_FontLoad( char *HanCode, PHAN_FONT_OBJ *FontPtr )   /* ѱ Ϲ Ʈ  */
{

	//static declaration  ӵ ̱ Ѱ.
	static U16 uChosung, uJoongsung, uJongsung, uChoType, uJooType,uJonType;

	//  ʱȭ
	memset(FontPtr->FontBuffer, 0x00, 32);


	FontPtr->Code_Type = PHAN_NULL_CODE;	
	// ѱڵ  
	// 
	if( !HanCode[0] || HanCode[0] == 0x0A )   // ڿ 
	{
		FontPtr->Code_Type = PHAN_END_CODE;
		FontPtr->Size_Char = 1;
		return PHAN_END_CODE;
	}
	else if( HanCode[0] & 0x80 )              // ѱ ڵΰ 
	{
		FontPtr->Code_Type = PHAN_HANGUL_CODE;
		FontPtr->Size_Char = 2;
		PHan_HanFontLoad( HanCode, FontPtr );
		return PHAN_HANGUL_CODE;
	}
	else                                      //  ڵ 
	{
		FontPtr->Code_Type = PHAN_ENG_CODE;
		FontPtr->Size_Char = 1;
		PHan_EngFontLoad( HanCode, FontPtr );
		return PHAN_ENG_CODE;
	}


	return FontPtr->Code_Type;

}





//----------------------------------------------------------------------------
//
//          TITLE : PHan_FontLoad
//
//          WORK  : 
//
//----------------------------------------------------------------------------
void PHan_HanFontLoad( char *HanCode, PHAN_FONT_OBJ *FontPtr )   /* ѱ Ϲ Ʈ  */
{
	U16 i;
	U16 wHanCode;	
	//static declaration  ӵ ̱ Ѱ.
	static U16 uChosung, uJoongsung, uJongsung, uChoType, uJooType,uJonType;

	wHanCode = (U16)HanCode[0]<<8  | (U16)HanCode[1] & 0x00FF;
	
	//printf("%x %x %x\n", HanCode[0], HanCode[1], HanCode[2] );

	wHanCode = PHan_CnvCodeWan2Johab(wHanCode);
	//printf("a %x \n", wHanCode );

	//seperate phoneme code
	uChosung   = (wHanCode>>10)&0x001F;//Chosung code
	uJoongsung = (wHanCode>>5) &0x001F;//Joongsung code
	uJongsung  = wHanCode & 0x001F;   //Jongsung code

	//make font index
	uChosung   = ChoIdxTbl[uChosung];    //Chosung index
	uJoongsung = JooIdxTbl[uJoongsung];  //Joongsung index
	uJongsung  = JonIdxTbl[uJongsung];   //Jongsung index

	//decide a character type (°   )
	uChoType = uJongsung ? ChoTypeCaseJongYes[uJoongsung]:ChoTypeCaseJongNo [uJoongsung];
	  //''(1) ̳ ''(16) ΰ
	uJooType = ((uChosung == 0 || uChosung == 1 ||uChosung == 16 ) ? 0: 1) + (uJongsung ? 2: 0);
	uJonType = JonType[uJoongsung];

	for(i = 0; i<32; i++)
	{
		FontPtr->FontBuffer[i]  = K_font[uChoType*20+uChosung][i];
		FontPtr->FontBuffer[i] |= K_font[160 + uJooType*22+uJoongsung][i];
	}

	//combine Jongsung
	if(uJongsung)
	{
		for(i = 0; i < 32; i++) 	FontPtr->FontBuffer[i] |= K_font[248 + uJonType*28+uJongsung][i];
	}
}





//----------------------------------------------------------------------------
//
//          TITLE : PHan_EngFontLoad
//
//          WORK  : 
//
//----------------------------------------------------------------------------
void PHan_EngFontLoad( char *HanCode, PHAN_FONT_OBJ *FontPtr ) 
{
	U16 i;
	char EngCode;

	EngCode = *HanCode;

	EngCode -= 0x20;  // FONT ̽  Ѵ.

	for ( i = 0 ; i < 16 ; i++ )
	{
		 FontPtr->FontBuffer[ i ] = wEngFon[EngCode][i];		
	}
}



/*----------------------------------------------------------------------*/
/*	bTemp1Font[72]  ѱ Ϲ Ʈ							*/
/*	Line Image Buffer Ѵ.										*/
/*----------------------------------------------------------------------*/
void PHan_MoveHanFont( char *ImageBuffer, PHAN_FONT_OBJ *FontPtr, int Xpos)
{
	int	i, j;


	for ( j = 0 ; j < 2 ; j++ )		// 16 x 16 (2 Bytes)
	{
		ImageBuffer[ Xpos*2 + j ] = FontPtr->FontBuffer[i*2 +j];
	}
}







void PHan_DisHanFont(PHAN_FONT_OBJ *FontPtr)
{
	U16	i, j, Loop;
	U16 FontSize = FontPtr->Size_Char;


	for ( i = 0 ; i < 16 ; i++ )		// 16 Lines per Font/Char
	{
		for ( j = 0 ; j < FontSize ; j++ )		// 16 x 16 (2 Bytes)
		{
			for( Loop=0; Loop<8; Loop++ )
			{
				if( FontPtr->FontBuffer[i*FontSize +j] & (0x80>>Loop)) printf("*");
				else                                         printf(" ");
				
			}
		}
		printf("   - \n");
		//printf("%x\n",FontPtr->FontBuffer[i]);
	}
}